/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operate_OperatorState_h__
#define __operate_OperatorState_h__

namespace fe
{

/**************************************************************************//**
	@brief Operator base class to save and reload state

	@ingroup operate
*//***************************************************************************/
class FE_DL_EXPORT OperatorState:
	virtual public OperatorSurfaceCommon,
	public Initialize<OperatorState>
{
	public:

								OperatorState(void)							{}
virtual							~OperatorState(void)						{}

		void					initialize(void);

								//* As OperatorSurfaceI
virtual	BWORD					saveState(String& rBuffer);
virtual	BWORD					loadState(const String& rBuffer);

	protected:

	class Pick
	{
		public:
					Pick(I32 a_index,Real a_weight):
						m_index(a_index),
						m_weight(a_weight)									{}

			I32		m_index;
			Real	m_weight;
	};

virtual	void					setupState(void)							{}

		BWORD					pickToggle(I32 a_index);
		Real					picked(I32 a_index);
		void					pick(I32 a_index,Real a_weight=1.0);

		void					updateIds(void);
		I32						lookupIndex(I32 a_id);
		I32						lookupId(I32 a_index);

		sp<Scope>				m_spScope;
		sp<RecordGroup>			m_spState;
		Accessor<I32>			m_aIndex;
		std::vector<Pick>		m_pickArray;

	private:

		sp<SurfaceAccessorI>	m_spInputIds;
		std::map<I32,I32>		m_indexMap;

};

} /* namespace */

#endif /* __operate_OperatorState_h__ */
